//https://www.bitabittecnologia.com.br

//Vídeo com exemplo deste código:
//https://youtu.be/41XX-4scuyg

#include  <Stepper.h>

#define FULL_STEP 2 //Biblioteca Stepper trabalha em full step
#define PASSOS_POR_VOLTA 64 //Motor de passo unipolar modelo 28BYJ-48 5V possui 64 passos por volta sem redução
#define ANGULO_DE_PASSO (5.625 / PASSOS_POR_VOLTA * FULL_STEP) //Motor de passo unipolar modelo 28BYJ-48 5V tem ângulo de passo de: 5,625 graus/64, resultado multiplica por full step

float rpm_eixo = 4;
int passos;

//Retorna a velocidade real que o motor tem que girar, para girar o eixo na velocidade desejada.
//Isso devido ao motor de passo ter engrenagens de redução
int velocidadeRealDaVelocidadeEixo(float velocidade_eixo, int reducao )
{
  int velocidade_real;

  velocidade_real = velocidade_eixo * reducao / FULL_STEP;
  return velocidade_real;
}

//Retorna o ângulo desejado para número de passos
int anguloParaPasso(int angulo)
{
  int passos;

  passos = angulo / ANGULO_DE_PASSO;

  return passos;
}

Stepper motor_passo(PASSOS_POR_VOLTA, 8, 10, 9, 11); //Passos_por_volta_do_motor, IN1, IN3, IN2, IN4

void setup() 
{
  int velocidade_real = velocidadeRealDaVelocidadeEixo(rpm_eixo, PASSOS_POR_VOLTA);

  motor_passo.setSpeed(velocidade_real); 

  passos = anguloParaPasso(270);
}

void loop() 
{
  motor_passo.step(passos); //Gira sentido horário
  delay(2000);
  motor_passo.step(-passos); //Gira sentido anti-horário
  delay(2000);
}
